Subject: Improved git-gui blame viewer

From: "Shawn O. Pearce" <[email-masked]>
Date: Sat, 2 Jun 2007 00:17:23 -0400

A long time ago Linus Torvalds <[email-masked]> wrote:
> 
> On Sun, 18 Mar 2007, Shawn O. Pearce wrote:
> > Linus Torvalds <[email-masked]> wrote:
> > > 
> > > Of course, the git gui blame colorization is clearly done by somebody who 
> > > is still actively popping LSD with both fists and didn't realize that the 
> > > 60's are long done, but that's another issue.
> > 
> > git-gui is open source.  I'd be happy to take a patch.  Or,
> > since that is horribly messy Tcl/Tk code, just a better color
> > suggestion. :-)
> 
> I would suggest:
> 
>  - some special color for "currently selected" (which defaults to being 
>    the first one coming out of the blame thing, of course). 
> 
>    I'd suggest "black text on pale green background", but that may be just 
>    me.
> 
>  - some *stable* graduated color for the rest. I don't think it 
>    necessarily needs to be "older" vs "newer", and in fact I'd suggest 
>    just two slightly different shades of gray for the background - just 
>    pick alternating shades for each blame entry that comes in (and leave 
>    un-blamed lines white).

I finally got the git-gui code to the point where cleaning up the
user interface was possible without sending myself to the nut house.

I tried out Linus' suggestions for coloring, and I like them.  Enough
that they are now sitting in my `pu` branch on repo.or.cz/git-gui.git.

There's also a whole slew of other improvements to the blame viewer,
like being able to dig through history by clicking on commit ids,
and tooltips when you mouse over a region of the file.

Behavior on Windows is actually quite good; its less so on Mac
OS X.  I'm fighting Tk there a little bit more than I should be.
Untested on Linux, so I'd love to hear some feedback on it.

  git://repo.or.cz/git-gui.git      pu
  http://repo.or.cz/r/git-gui.git   pu
 
-- 
Shawn.